From a1a736d4327029be87fdc9a081c1d1601a7822d3 Mon Sep 17 00:00:00 2001
From: Alexey Shabalin <shaba@altlinux.org>
Date: Tue, 23 Aug 2011 17:35:23 +0400
Subject: [PATCH] - Change --with-config-path in configure for define path for
 config files.

- Add --with-container-path to configure for define path for containers
repository. Allow install config files for containers to /etc/lxc dir.
For old way you can use same --with-config-path and --with-container-path.
---
 configure                 | 6701 +++++++++++++++++++++++++++++++++++++++++++++
 configure.ac              |   11 +-
 src/lxc/lxc-clone.in      |   34 +-
 src/lxc/lxc-create.in     |    8 +-
 src/lxc/lxc-destroy.in    |    7 +-
 src/lxc/lxc_execute.c     |    2 +-
 src/lxc/lxc_restart.c     |    2 +-
 src/lxc/lxc_start.c       |    2 +-
 templates/lxc-busybox.in  |    9 +-
 templates/lxc-debian.in   |    7 +-
 templates/lxc-fedora.in   |    5 +-
 templates/lxc-lenny.in    |    7 +-
 templates/lxc-opensuse.in |   11 +-
 templates/lxc-sshd.in     |    9 +-
 templates/lxc-ubuntu.in   |   15 +-
 15 files changed, 6775 insertions(+), 55 deletions(-)
 create mode 100755 configure

Index: lxc-0.8.0/configure.ac
===================================================================
--- lxc-0.8.0.orig/configure.ac
+++ lxc-0.8.0/configure.ac
@@ -61,7 +61,13 @@ AC_ARG_WITH([config-path],
 	[AC_HELP_STRING(
 		[--with-config-path=dir],
 		[lxc configuration repository path]
-	)], [], [with_config_path=['${localstatedir}/lib/lxc']])
+	)], [], [with_config_path=['${sysconfdir/lxc']])
+
+AC_ARG_WITH([container-path],
+	[AC_HELP_STRING(
+		[--with-container-path=dir],
+		[lxc containers repository path]
+	)], [], [with_container_path="${localstatedir}/lib/lxc"])
 
 AC_ARG_WITH([rootfs-path],
 	[AC_HELP_STRING(
@@ -70,7 +76,8 @@ AC_ARG_WITH([rootfs-path],
 	)], [], [with_rootfs_path=['${libdir}/lxc/rootfs']])
 
 AS_AC_EXPAND(LXC_GENERATE_DATE, "$(date)")
-AS_AC_EXPAND(LXCPATH, "${with_config_path}")
+AS_AC_EXPAND(LXCETCPATH, "${with_config_path}")
+AS_AC_EXPAND(LXCPATH, "${with_container_path}")
 AS_AC_EXPAND(LXCROOTFSMOUNT, "${with_rootfs_path}")
 AS_AC_EXPAND(LXCTEMPLATEDIR, ['${datadir}/lxc/templates'])
 
Index: lxc-0.8.0/src/lxc/lxc-clone.in
===================================================================
--- lxc-0.8.0.orig/src/lxc/lxc-clone.in
+++ lxc-0.8.0/src/lxc/lxc-clone.in
@@ -47,6 +47,7 @@ help() {
 shortoptions='ho:n:sL:v:p:t:'
 longoptions='help,orig:,name:,snapshot,fssize:,vgname:,lvprefix:,fstype:'
 lxc_path=@LXCPATH@
+config_path=@LXCETCPATH@
 bindir=@BINDIR@
 snapshot=no
 lxc_defsize=2G
@@ -137,12 +138,12 @@ if [ "$(id -u)" != "0" ]; then
    exit 1
 fi
 
-if [ ! -d "$lxc_path/$lxc_orig" ]; then
+if [ ! -d "$lxc_path/$lxc_orig" -o ! -f "$config_path/$lxc_orig/config" ]; then
     echo "$(basename $0): '$lxc_orig' does not exist" >&2
     exit 1
 fi
 
-if [ -d "$lxc_path/$lxc_new" ]; then
+if [ -d "$lxc_path/$lxc_new" -o -f "$config_path/$lxc_new/config"  ]; then
     echo "$(basename $0): '$lxc_new' already exists" >&2
     exit 1
 fi
@@ -168,28 +169,29 @@ cleanup() {
 trap cleanup HUP INT TERM
 
 mkdir -p $lxc_path/$lxc_new
+mkdir -p $config_path/$lxc_new
 hostname=$lxc_new
 
 echo "Tweaking configuration"
-cp $lxc_path/$lxc_orig/config $lxc_path/$lxc_new/config
-sed -i '/lxc.utsname/d' $lxc_path/$lxc_new/config
-echo "lxc.utsname = $hostname" >> $lxc_path/$lxc_new/config
-
-grep "lxc.mount[ \t]" $lxc_path/$lxc_new/config >/dev/null 2>&1 && { sed -i '/lxc.mount[ \t]/d' $lxc_path/$lxc_new/config; echo "lxc.mount = $lxc_path/$lxc_new/fstab" >> $lxc_path/$lxc_new/config; }
-
-if [ -e  $lxc_path/$lxc_orig/fstab ];then
-    cp $lxc_path/$lxc_orig/fstab $lxc_path/$lxc_new/fstab
-    sed -i "s@$lxc_path/$lxc_orig@$lxc_path/$lxc_new@" $lxc_path/$lxc_new/fstab
+cp $config_path/$lxc_orig/config $config_path/$lxc_new/config
+sed -i '/lxc.utsname/d' $config_path/$lxc_new/config
+echo "lxc.utsname = $hostname" >> $config_path/$lxc_new/config
+
+grep "lxc.mount[ \t]" $config_path/$lxc_new/config >/dev/null 2>&1 && { sed -i '/lxc.mount[ \t]/d' $config_path/$lxc_new/config; echo "lxc.mount = $config_path/$lxc_new/fstab" >> $config_path/$lxc_new/config; }
+
+if [ -e  $config_path/$lxc_orig/fstab ];then
+    cp $config_path/$lxc_orig/fstab $config_path/$lxc_new/fstab
+    sed -i "s@$config_path/$lxc_orig@$config_path/$lxc_new@" $config_path/$lxc_new/fstab
 fi
 
 echo "Copying rootfs..."
-oldroot=`grep lxc.rootfs $lxc_path/$lxc_orig/config | awk -F'[= \t]+' '{ print $2 }'`
+oldroot=`grep lxc.rootfs $config_path/$lxc_orig/config | awk -F'[= \t]+' '{ print $2 }'`
 rootfs=`echo $oldroot |sed "s/$lxc_orig/$lxc_new/"`
 
 container_running=True
 lxc-info -s -n $lxc_orig|grep RUNNING >/dev/null 2>&1 || container_running=False
 
-sed -i '/lxc.rootfs/d' $lxc_path/$lxc_new/config
+sed -i '/lxc.rootfs/d' $config_path/$lxc_new/config
 if [ -b $oldroot ]; then
     type vgscan || { echo "$(basename $0): lvm is not installed" >&2; false; }
     lvdisplay $oldroot > /dev/null 2>&1 || { echo "$(basename $0): non-lvm blockdev cloning is not supported" >&2; false; }
@@ -219,7 +221,7 @@ if [ -b $oldroot ]; then
         mount /dev/$lxc_vg/${lxc_lv_prefix}${lxc_new}_snapshot ${rootfs}_snapshot || { echo "$(basename $0): failed to mount new rootfs_snapshot" >&2; false; }
         #create a new lv
         lvcreate -L $lxc_size $lxc_vg -n ${lxc_lv_prefix}$lxc_new
-        echo "lxc.rootfs = /dev/$lxc_vg/${lxc_lv_prefix}$lxc_new" >> $lxc_path/$lxc_new/config
+        echo "lxc.rootfs = /dev/$lxc_vg/${lxc_lv_prefix}$lxc_new" >> $config_path/$lxc_new/config
         # and mount it so we can tweak it
         mkdir -p $rootfs
         mkfs -t $fstype /dev/$lxc_vg/${lxc_lv_prefix}$lxc_new
@@ -231,7 +233,7 @@ if [ -b $oldroot ]; then
         lvremove -f $lxc_vg/${lxc_lv_prefix}${lxc_new}_snapshot
     else
         lvrename $lxc_vg/${lxc_lv_prefix}${lxc_new}_snapshot $lxc_vg/${lxc_lv_prefix}$lxc_new
-        echo "lxc.rootfs = /dev/$lxc_vg/${lxc_lv_prefix}$lxc_new" >> $lxc_path/$lxc_new/config
+        echo "lxc.rootfs = /dev/$lxc_vg/${lxc_lv_prefix}$lxc_new" >> $config_path/$lxc_new/config
         # and mount it so we can tweak it
         mkdir -p $rootfs
         mount /dev/$lxc_vg/${lxc_lv_prefix}$lxc_new $rootfs || { echo "$(basename $0): failed to mount new rootfs" >&2; false; }
@@ -241,7 +243,7 @@ if [ -b $oldroot ]; then
 elif which btrfs >/dev/null 2>&1 && btrfs subvolume list $oldroot >/dev/null 2>&1; then
     # if oldroot is a btrfs subvolume, assume they want a snapshot
     btrfs subvolume snapshot "$oldroot" "$rootfs" 2>&1 || { echo "$(basename $0): btrfs snapshot failed" >&2; false; }
-    echo "lxc.rootfs = $rootfs" >> "$lxc_path/$lxc_new/config"
+    echo "lxc.rootfs = $rootfs" >> "$config_path/$lxc_new/config"
 else
     if [ $snapshot = "yes" ]; then
         echo "$(basename $0): cannot snapshot a directory" >&2
@@ -253,7 +255,7 @@ else
     fi
     mkdir -p $rootfs/
     rsync -ax $oldroot/ $rootfs/
-    echo "lxc.rootfs = $rootfs" >> $lxc_path/$lxc_new/config
+    echo "lxc.rootfs = $rootfs" >> $config_path/$lxc_new/config
     if [ $container_running = "True" ]; then
         lxc-unfreeze -n $lxc_orig
         frozen=0
@@ -267,7 +269,7 @@ if [ -f $rootfs/etc/dhcp/dhclient.conf ]
     sed -i "s/send host-name.*$/send host-name \"$hostname\";/" $rootfs/etc/dhcp/dhclient.conf
 fi
 
-c=$lxc_path/$lxc_new/config
+c=$config_path/$lxc_new/config
 # change hwaddrs
 mv ${c} ${c}.old
 (
Index: lxc-0.8.0/src/lxc/lxc-create.in
===================================================================
--- lxc-0.8.0.orig/src/lxc/lxc-create.in
+++ lxc-0.8.0/src/lxc/lxc-create.in
@@ -63,6 +63,7 @@ help() {
 shortoptions='hn:f:t:B:'
 longoptions='help,name:,config:,template:,backingstore:,fstype:,lvname:,vgname:,fssize:'
 lxc_path=@LXCPATH@
+lxc_etc_path=@LXCETCPATH@
 bindir=@BINDIR@
 templatedir=@LXCTEMPLATEDIR@
 backingstore=_unset
@@ -179,7 +180,7 @@ case "$backingstore" in
         ;;
 esac
 
-if [ -d "$lxc_path/$lxc_name" ]; then
+if [ -d "$lxc_path/$lxc_name" -o -d "$lxc_etc_path/$lxc_name" ]; then
     echo "$(basename $0): '$lxc_name' already exists" >&2
     exit 1
 fi
@@ -246,16 +247,17 @@ cleanup() {
 trap cleanup HUP INT TERM
 
 mkdir -p $lxc_path/$lxc_name
+mkdir -p $lxc_etc_path/$lxc_name
 
 if [ -z "$lxc_config" ]; then
-    touch $lxc_path/$lxc_name/config
+    touch $lxc_etc_path/$lxc_name/config
 else
     if [ ! -r "$lxc_config" ]; then
 	echo "$(basename $0): '$lxc_config' configuration file not found" >&2
 	exit 1
     fi
 
-    cp $lxc_config $lxc_path/$lxc_name/config
+    cp $lxc_config $lxc_etc_path/$lxc_name/config
 fi
 
 # Create the fs as needed
Index: lxc-0.8.0/src/lxc/lxc-destroy.in
===================================================================
--- lxc-0.8.0.orig/src/lxc/lxc-destroy.in
+++ lxc-0.8.0/src/lxc/lxc-destroy.in
@@ -42,6 +42,7 @@ help() {
 shortoptions='hn:f'
 longoptions='help,name:'
 lxc_path=@LXCPATH@
+lxc_etc_path=@LXCETCPATH@
 force=0
 
 getopt=$(getopt -o $shortoptions --longoptions  $longoptions -- "$@")
@@ -88,7 +89,7 @@ if [ "$(id -u)" != "0" ]; then
    exit 1
 fi
 
-if [ ! -d "$lxc_path/$lxc_name" ]; then
+if [ ! -d "$lxc_path/$lxc_name" -a ! -f "$lxc_etc_path/$lxc_name/config" ]; then
     echo "$(basename $0): '$lxc_name' does not exist" >&2
     exit 1
 fi
@@ -108,7 +109,7 @@ fi
 # Deduce the type of rootfs
 # If LVM partition, destroy it. For btrfs, we delete the subvolue. If anything
 # else, ignore it. We'll support deletion of others later.
-rootdev=`grep lxc.rootfs $lxc_path/$lxc_name/config 2>/dev/null | sed -e 's/^[^/]*/\//'`
+rootdev=`grep lxc.rootfs $lxc_etc_path/$lxc_name/config 2>/dev/null | sed -e 's/^[^/]*/\//'`
 if [ -n "$rootdev" ]; then
 	if [ -b "$rootdev" ]; then
 		lvdisplay $rootdev > /dev/null 2>&1
@@ -127,4 +128,4 @@ if [ -n "$rootdev" ]; then
 	fi
 fi
 # recursively remove the container to remove old container configuration
-rm -rf --one-file-system --preserve-root $lxc_path/$lxc_name
+rm -rf --one-file-system --preserve-root $lxc_etc_path/$lxc_name $lxc_path/$lxc_name
Index: lxc-0.8.0/src/lxc/lxc_execute.c
===================================================================
--- lxc-0.8.0.orig/src/lxc/lxc_execute.c
+++ lxc-0.8.0/src/lxc/lxc_execute.c
@@ -109,7 +109,7 @@ int main(int argc, char *argv[])
 	else {
 		int rc;
 
-		rc = asprintf(&rcfile, LXCPATH "/%s/config", my_args.name);
+		rc = asprintf(&rcfile, LXCETCPATH "/%s/config", my_args.name);
 		if (rc == -1) {
 			SYSERROR("failed to allocate memory");
 			return -1;
Index: lxc-0.8.0/src/lxc/lxc_restart.c
===================================================================
--- lxc-0.8.0.orig/src/lxc/lxc_restart.c
+++ lxc-0.8.0/src/lxc/lxc_restart.c
@@ -132,7 +132,7 @@ int main(int argc, char *argv[])
 	else {
 		int rc;
 
-		rc = asprintf(&rcfile, LXCPATH "/%s/config", my_args.name);
+		rc = asprintf(&rcfile, LXCETCPATH "/%s/config", my_args.name);
 		if (rc == -1) {
 			SYSERROR("failed to allocate memory");
 			return -1;
Index: lxc-0.8.0/src/lxc/lxc_start.c
===================================================================
--- lxc-0.8.0.orig/src/lxc/lxc_start.c
+++ lxc-0.8.0/src/lxc/lxc_start.c
@@ -136,7 +136,7 @@ int main(int argc, char *argv[])
 	else {
 		int rc;
 
-		rc = asprintf(&rcfile, LXCPATH "/%s/config", my_args.name);
+		rc = asprintf(&rcfile, LXCETCPATH "/%s/config", my_args.name);
 		if (rc == -1) {
 			SYSERROR("failed to allocate memory");
 			return err;
